#pragma once

#include "plot_2dplot.h"
#include "plot_2dpure.h"

namespace plot {

class TPure2dPlotPrivate
{
    Q_DECLARE_PUBLIC(TPure2dPlot);
    QPointF FindAltitude(const QPointF &Click, const QPointF &Closest, const QPointF &p) const;
    double GetDist(const QPointF &p1, const QPointF &p2) const { return qSqrt(qPow(p2.x() - p1.x(), 2) + qPow(p2.y() - p1.y(), 2)); }
    bool PointBelongToLine(const QPointF &P, const QLineF &Line) const;
public:
    TPure2dPlotPrivate();
    TPure2dPlot *q_ptr;

    QPointF GetIntersectPoint(const QwtPlotCurve *Curve, const QPoint &ScrPos, int &Idx) const;

    bool ZoomBySelection;
    bool AutoScaleEnabled;
    int SelectedPointForMC;

    TGeneralMarkerInfoHandler AMarkerInfo;
    TGeneralMarkerInfoHandler BMarkerInfo;
    TPure2dPlot::TModes State;
};

}
