#include "plot_events.h"

namespace plot {

QEvent::Type TSelectEvent::id = (QEvent::Type)QEvent::registerEventType();
QEvent::Type TCrossEvent::id = (QEvent::Type)QEvent::registerEventType();
QEvent::Type TScalesChangedEvent::id = (QEvent::Type)QEvent::registerEventType();

TSelectEvent::TSelectEvent(const QRectF &Rect, TSelectEvent::States St, TSelectEvent::TSelectRectChangedOrigins Or): QEvent(id)
{
    State = St;
    SelectedRect = Rect;
    Origin = Or;
}
TCrossEvent::TCrossEvent(const QPointF &Point): QEvent(id)
{
    Coord = Point;
}
TScalesChangedEvent::TScalesChangedEvent(const Range &XLims, const Range &YLims, TReason Rsn): QEvent(id)
{
    Reason = Rsn;
    XLimits = XLims;
    YLimits = YLims;
}

}
