#ifndef SUBSTPLANE_H
#define SUBSTPLANE_H

namespace plot {
namespace math {

int mathCholeskiDecompose(int dim, double *a);
void mathCholeskiSolve(int dim, const double *a, double *b);

template <class T>
double *dataFieldAreaFitPolynom(T &array, int col, int row, int width, int height, int col_degree, int row_degree, double *coeffs);
template <class T>
void dataFieldAreaSubtractPolynom(T &array, int col, int row, int width, int height, int col_degree, int row_degree, const double *coeffs);

double *dataLinePartFitPolynom(double *data, int n, double *coeffs, int from, int to);
void dataLinePartSubtractPolynom(double *data, int n, const double *coeffs, int from, int to);

}
}

#endif //SUBSTPLANE_H

