#include "camvideosurceface.h"

#include <QAbstractVideoSurface>
#include <QDebug>

QList<QVideoFrame::PixelFormat> CamVideoSurceface::supportedPixelFormats(
        QAbstractVideoBuffer::HandleType handleType) const
{
    qDebug("Frame format");
    if (handleType == QAbstractVideoBuffer::NoHandle) {
        return QList<QVideoFrame::PixelFormat>()
                << QVideoFrame::Format_RGB32;
                //<< QVideoFrame::Format_RGB24;
    } else {
        return QList<QVideoFrame::PixelFormat>();
    }
}

bool CamVideoSurceface::present(const QVideoFrame& frame)
{
    //qDebug("present");
    if (frame.isValid()) {
        QVideoFrame cloneFrame(frame);
        //cloneFrame.map(QAbstractVideoBuffer::ReadOnly);
        cloneFrame.map(QAbstractVideoBuffer::ReadWrite);
        const QImage img(cloneFrame.bits(),
                     cloneFrame.width(),
                     cloneFrame.height(),
                     QVideoFrame::imageFormatFromPixelFormat(cloneFrame.pixelFormat()));

        const QImage img2 = img.copy(img.rect());
        emit ImgReceived(img2);

        cloneFrame.unmap();
        return true;
    }
    return false;
}

