#ifndef VIDEOSETTINGS_H
#define VIDEOSETTINGS_H

#include <QList>

class videoObjectiveProfile
{
public:
    QString name = QObject::tr("Empty");

    int rangeX = 1024;
    int rangeY = 768;
    int height = 100;
    int width = 100;
    double stageHeadCantX = 0.;
    double stageHeadCantY = 0.;
    double stageLaserX = 0.;
    double stageLaserY = 0.;

    int afD0 = 5000;
    int afVst = 200;
    int afVpr = 3;
    int afCrat = 100;
    double afCrat2 = 0.20;
    int afCratPrecize = 100;
    int afLeftStPr = 5;
};

class videoSettings
{
public:
    QList<videoObjectiveProfile*> objProfiles;

    int lastSelectedObjProfile = 0;

    bool flipX = false;
    bool flipY = false;
    bool swapXY = false;
    bool mafPrcsEnabled = true;
    bool mafFastEnabled = true;
    bool pafEnabled = true;
    bool mafPaf = false;
    int xyMsel = 2;
    int motorZFocusSpeed = 1;
    int motorXYStageSpeed = 1;
    int afExitDistance = 10;
    int tipThinkbness = 0;
};

#endif // VIDEOSETTINGS_H
