#include "cont_filesproccessing.h"
#include <QDebug>

void TFileProccessing::ConnectSlots()
{
    connect(&Nst, SIGNAL(FileProccessed(double, double )),      this, SIGNAL(FileProccessed(double, double )));
    connect(&Nst, SIGNAL(AllDataLoaded(const TAbstractInfos *)), this, SIGNAL(AllDataLoaded(const TAbstractInfos *)));
    connect(&Nst, SIGNAL(DoAddBlanks(int )),                     this, SIGNAL(DoAddBlanks(int )));
    connect(&Nst, SIGNAL(Error(QString,QString)),                this, SIGNAL(Error(QString,QString)));
}
void TFileProccessing::Load(const QString &File, TAbstractInfos *Dt)
{
    Action = TFileProccessing::ActLoad;
    FileName = File;
    LoadingData = Dt;
    start();
}
void TFileProccessing::Save(const QString &File, const TAbstractInfos *Dt)
{
    Action = TFileProccessing::ActSave;
    FileName = File;
    SavingData = Dt;
    start();
}
void TFileProccessing::run()
{
    if (Action == TFileProccessing::ActSave) _Save();
    else if (Action == TFileProccessing::ActLoad) _Load();
    Action = TFileProccessing::ActNone;
}
void TFileProccessing::_Save()
{
    try {
        if (FileName.endsWith(".nstdat"))
            Nst.Save(FileName, *SavingData, false);
        else if (FileName.endsWith(".gwy"))
            Nst.Save(FileName, *SavingData, true);
    } catch (char *str) {
        qDebug() << "file processing exception: " << str;
        emit Error(tr("Save error"), str);
    } catch (...) {
        qDebug() << "file processing exception";
        emit Error(tr("Save error"), tr("Unknown error."));
    }

    delete SavingData;
    SavingData = nullptr;
}
void TFileProccessing::_Load()
{
    if (FileName.endsWith(".nstdat"))
        Nst.Load(FileName, *LoadingData);
}
