#pragma once

#include <QListWidget>
#include "cont_basetypes.h"
#include <2d/plot_2dtypes.h>
#include <3d/plot_3dtypes.h>
#include <QsKineticScroller.h>

class TListWidget;
class TListItem : public TAbstractInfo
{
public:
    TListItem(plot::TMetaStorage attributes, void *data, int type, TListWidget *Parent, bool UpdPr);
    ~TListItem();

    QListWidgetItem *Item;
};
typedef QList<TListItem *> TListItems;


class TContainer;
class TListWidget: public QListWidget
{
    Q_OBJECT
signals:
    void ItemClicked(const plot::TCurvesDataOwner *);
    void ItemClicked(const plot::T3dDataOwner *);
    void ItemClicked(const ccd::TSetOfSpectrum *);
    void ItemClicked(const QImage);

public slots:
    void on_itemPressed(QListWidgetItem *);
    void on_nameChanged(QListWidgetItem *);
    void slotCustomMenuRequested(QPoint);
    void DeleteSelectedItems();
    bool eventFilterScroll(QObject *Object, QEvent *Event);

public:
    #ifndef _ADROID
    void resizeEvent(QResizeEvent *) override;
#endif
    void ClearAll();
    void Delete(int N = -1);

    void AddBlanks(int N);
    QListWidgetItem *FindFirstBlank();
    void Add(plot::TMetaStorage attributes, plot::TCurvesDataOwner *data, bool UpdatePreview = false);
    void Add(plot::TMetaStorage attributes, plot::T3dDataOwner *data, bool UpdatePreview = false);
    void Add(plot::TMetaStorage attributes, ccd::TSetOfSpectrum *Info, bool UpdatePreview = false);
    void Add(plot::TMetaStorage attributes, QImage Info, bool UpdatePreview = false);

    void fitTextInItem(QListWidgetItem *Item);

    TListItem *FindItem(QListWidgetItem *Item) const;

    TListWidget(TContainer *cont);
    ~TListWidget() override;

    QsKineticScroller *scroll;
    TListItems DataList;
    TListItem *ClickedItem;
    QString filename;
    bool blockAllMouseEvents = false;
    TContainer *cont = nullptr;
    bool isUpdated;
    bool rightButtonPressed;
    QPoint originMouseSelectionPos;
    QRubberBand *rubberBand;
    bool mouseRectSelecting;
    bool needToResize = true;

    bool event(QEvent *e) override;

    void dragEnterEvent(QDragEnterEvent *) override; //fuck qt 2
    void dragMoveEvent(QDragMoveEvent *) override; //fuck qt 3
    void dropEvent(QDropEvent *event) override; //fuck qt
    QStringList mimeTypes() const override;
    QMimeData *mimeData(const QList<QListWidgetItem *> items) const override;
    bool dropMimeData(int index, const QMimeData *data, Qt::DropAction action) override;

    void focusInEvent(QFocusEvent *) override { } //fuck qt
};
