#ifndef GWYNETIO_H_
#define GWYNETIO_H_

#include <QThread>
#include <plot.h>

class QTcpSocket;
class QTcpServer;
namespace ccd { class TSetOfSpectrum; }

class GwyddionExport : public QThread
{
    Q_OBJECT

public slots:
    void accept_and_send();

signals:
    void no_gwyddion();

public:
    GwyddionExport();
    ~GwyddionExport() override;

    void run() override;
    void AddData(void *data, int type, plot::TMetaStorage &meta);
    QTcpSocket *client;
    QTcpServer *server;
    QByteArray buffer;
    char count;
};

class GwyddionImport : public QThread
{
    Q_OBJECT

public slots:
    void accept_and_recv();

signals:
    void AddDataToContainer(plot::TCurvesDataOwner, plot::TMetaStorage);
    void AddDataToContainer(plot::T3dDataOwner, plot::TMetaStorage);
    void AddDataToContainer(ccd::TSetOfSpectrum *, plot::TMetaStorage);
    void Refresh();

public:
    GwyddionImport();

    void run() override;
    QTcpServer *server;

};


#endif /* GWYNETIO_H_ */
