//http://blog.codeimproved.net/posts/kinetic-scrolling.html
//Written by raz
//BSD license
#pragma once

#include <QObject>
#include <QScopedPointer>
class QsKineticScrollerImpl;
class QAbstractScrollArea;
class QAbstractItemView;
class QEvent;

class QsKineticScroller: public QObject
{
    Q_OBJECT
public:
    QsKineticScroller(QObject* parent = nullptr);
    ~QsKineticScroller() override;
    void enableKineticScrollFor(QAbstractScrollArea* scrollArea = nullptr);

public: signals:
    bool eventFilterSignal(QObject* object, QEvent* event);

protected:
    bool eventFilter(QObject* object, QEvent* event) override;

private slots:
    void onKineticTimerElapsed();

private:
    QScopedPointer<QsKineticScrollerImpl> d;
};

QsKineticScroller* addScroller(QAbstractScrollArea *target);
QsKineticScroller* addScroller(QAbstractItemView *target);
