#include "colorrect.h"
#include <QPainter>
#include <QPainterPath>

colorRect::colorRect(QColor color, QWidget *parent) : QWidget(parent)
{
    this->color = color;
}

void colorRect::paintEvent(QPaintEvent *)
{
    QPainter painter(this);

    int w = width();
    int h = height();

    painter.setRenderHint(QPainter::Antialiasing, true);

    painter.setPen(QColor(color));
    painter.setBrush(QBrush(color));
    painter.drawRect(0, 0, w, h);
    painter.setBrush(QBrush());

    painter.setPen(QColor(100, 100, 100));
    painter.drawLine(0, 0, w, 0);
    painter.drawLine(0, h, w, h);
}
