#pragma once

#include <QLayout>

void addDelimeterV(QLayout *lay, short size);
void addDelimeterH(QLayout *lay, short size);

class VFlowLayout : public QLayout
{
public:
    VFlowLayout(QWidget *parent = nullptr);
    ~VFlowLayout() override;

    void addItem(QLayoutItem *item) override;
    void insertWidget(int pos, QWidget *wid);
    int count() const override;
    QLayoutItem *itemAt(int index) const override;
    QLayoutItem *takeAt(int index) override;

    void setGeometry(const QRect &rect) override;
    QSize minimumSize() const override;
    QSize maximumSize() const override;
    QSize sizeHint() const override;
    Qt::Orientations expandingDirections() const override;
    bool hasHeightForWidth() const override;
    int	heightForWidth(int w) const override;

    int spaceX = 0;
    int spaceY = 0;

protected:
    virtual int doLayout(const QRect &rect, bool testOnly) const;
    QList<QLayoutItem *> itemList;
};

class HFlowLayout : public VFlowLayout
{
public:
    HFlowLayout(QWidget *parent = nullptr);

    void setGeometry(const QRect &rect) override;
    QSize minimumSize() const override;
    Qt::Orientations expandingDirections() const override;
    bool hasHeightForWidth() const override;

protected:
    int doLayout(const QRect &rect, bool testOnly) const override;
    int prev_height = -1;
};
