#pragma once

#include <QLayout>

//uses minimumSize() for aspect ratio
class RatioLayout : public QLayout
{
public:
    RatioLayout(QWidget *parent = nullptr);
    ~RatioLayout() override;

    void addItem(QLayoutItem *item) override;
    int count() const;
    QLayoutItem *itemAt(int index) const override;
    QLayoutItem *takeAt(int index) override;

    void setGeometry(const QRect &rect) override;
    QSize minimumSize() const override;
    QSize maximumSize() const override;
    QSize sizeHint() const override;
    Qt::Orientations expandingDirections() const override;

protected:
    QLayoutItem *item = nullptr;
};
