#include "schPlus.h"

schPlus::schPlus(QWidget *parent) : QWidget(parent), AbstractInOutLines(1, 2)
{
    radius = 0;
}

void schPlus::recalcPoints()
{
    initPositions(width(), height());

    setPtsInXY(0, 0, width()*0.5);
    setPtsInXY(1, width()*0.5, height());
    setPtsOutXY(0, width(), width()*0.5);
}

void schPlus::initPositions(int w, int )
{
    radius = w*0.45;
}

bool schPlus::event(QEvent *e)
{
    if (QEventResizedMoved(e))
        recalcPoints();

    return QWidget::event(e);
}

void schPlus::paintEvent(QPaintEvent *)
{
    QPainter painter(this);

    int w = width();
    int h = height();

    initPositions(w, h);
    painter.setRenderHint(QPainter::Antialiasing, true);

    //Ellipse
    painter.setPen(QColor(Qt::black));
    painter.setBrush(QBrush(backgroundColor));
    painter.drawEllipse(QPoint(w*0.5, w*0.5), radius, radius);
    painter.setBrush(QBrush());

    //Plus lines
    painter.drawLine(w*0.5, w*0.25, w*0.5, w*0.75);
    painter.drawLine(w*0.25, w*0.5, w*0.75, w*0.5);
}
