#ifndef SCHLOCKIN_H
#define SCHLOCKIN_H

#include <QObject>
#include <QWidget>
#include "abstractinoutlines.h"
#include <QtEvents>
#include <QGestureEvent>
#include <QPainter>
#include <QDebug>
#include <QtGlobal>
#include <QTimer>
#include <QPaintEngine>
#include "gui/edit.hpp"
#include <QLabel>

class schLockIn : public QWidget, public AbstractInOutLines
{
    Q_OBJECT
public:
    explicit schLockIn(QWidget *parent = nullptr);
    void recalcPoints() override;

    Edit *edLP;
    Edit *edPSh;

protected:
    bool event(QEvent *) override;
    void paintEvent(QPaintEvent *event) override;

private:
    inline void initPositions(int w, int h);
    QLabel *headText;
    QLabel *LPText;
    QLabel *PShText;
    int boxX;
    int boxY;
    int boxW;
    int boxH;

signals:
    void recalc();

public slots:
};

#endif // SCHLOCKIN_H
