#ifndef SCHOSCELATOR_H
#define SCHOSCELATOR_H

#include <QObject>
#include <QWidget>
#include "abstractinoutlines.h"
#include <QtEvents>
#include <QGestureEvent>
#include <QPainter>
#include <QDebug>
#include <QtGlobal>
#include <QTimer>
#include <QPaintEngine>
#include <QLayout>
#include <QPushButton>
#include <QComboBox>
#include <QLabel>
#include <QCheckBox>
#include <QSettings>
#include <QLabel>
#include "controls.h"
#include "edit.hpp"
#include "tools.hpp"

class schOscilator : public QWidget, public AbstractInOutLines
{
    Q_OBJECT
public:
    explicit schOscilator(QWidget *parent = nullptr);
    void recalcPoints() override;
    void SetFreqCurveDataMaximum(float yMax);
    void virtual AddFreqCurveData(int x, qreal y);

    Edit *edFreq;
    Edit *edAmp;

    TwoStateButton *btnFreqStartScan;
    QPushButton *btnAutoFreqScan;
    QComboBox *cbChannel;
    Edit *edFreqScanMin;
    Edit *edFreqScanMax;
    QCheckBox *chbSecHarmonic;
    QCheckBox *chbSetOn;

    QVBoxLayout *mainBLay;
    QHBoxLayout *mainHLay;
    QVBoxLayout **subVLays;

protected:
    bool event(QEvent *) override;
    void paintEvent(QPaintEvent *event) override;

private:
    inline void initPositions(int w, int h);
    void drawFreqCurveGraph(QPainter *painter, int xLeftFC);
    QFont font;
    QLabel *headText;
    QLabel *freqText;
    QLabel *amplText;
    QLabel *channelLabel;
    QLabel *fromLabel;
    QLabel *toLabel;
    QLabel *khzLabel;
    int boxX;
    int boxY;
    int boxW;
    int boxH;
    QPolygonF freqCurve;
    QPolygonF freqCurveDraw;
    float fresX = 0.0;

signals:

public slots:
};

#endif // SCHOSCELATOR_H
