#ifndef SCHPID_H
#define SCHPID_H

#include <QObject>
#include <QWidget>
#include "abstractinoutlines.h"
#include <QtEvents>
#include <QGestureEvent>
#include <QPainter>
#include <QDebug>
#include <QtGlobal>
#include <QTimer>
#include <QPaintEngine>
#include "gui/edit.hpp"
#include <QLabel>
#include <QLayout>
#include "controls.h"

class schPID : public QWidget, public AbstractInOutLines
{
    Q_OBJECT
public:
    explicit schPID(QWidget *parent = nullptr);
    void recalcPoints() override;

    Edit *edPr;
    Edit *edInt;
    TwoStateButton *tsbFBSign;

protected:
    bool event(QEvent *) override;
    void paintEvent(QPaintEvent *event) override;

private:
    inline void initPositions(int w, int h);
    int boxX;
    int boxY;
    int boxW;
    int boxH;
    QLabel *headText;
    QLabel *prText;
    QLabel *intText;
    QLabel *FBSignText;
    QVBoxLayout *mainVLay;

signals:

public slots:
};

#endif // SCHPID_H
