#ifndef SCHPIEZO_H
#define SCHPIEZO_H

#include <QObject>
#include <QWidget>
#include "abstractinoutlines.h"
#include <QtEvents>
#include <QGestureEvent>
#include <QPainter>
#include <QDebug>
#include <QtGlobal>
#include <QTimer>
#include <QPaintEngine>
#include <QLabel>

class schpiezo : public QWidget, public AbstractInOutLines
{
    Q_OBJECT
public:
    explicit schpiezo(QWidget *parent = nullptr);
    void recalcPoints() override;

protected:
    bool event(QEvent *) override;
    void paintEvent(QPaintEvent *event) override;

private:
    inline void initPositions(int w, int h);
    QLabel *piezoText;

    int box1X;
    int box1Y;
    int box1W;
    int box1H;
    int box2X;
    int box2Y;
    int box2W;
    int box2H;

    QColor lBoxColor;
    QColor rBoxColor;

public slots:
};

#endif // SCHPIEZO_H
