#include "schpoint.h"

schPoint::schPoint(uint numIn, uint numOut, QWidget *parent) :
    QWidget(parent), AbstractInOutLines(numOut, numIn)
{
    center = 0;
}

void schPoint::recalcPoints()
{
    initPositions(width(), height());

    for(uint i=0; i<countIn; i++)
        setPtsInXY(i, center, center);
    for(uint i=0; i<countOut; i++)
        setPtsOutXY(i, center, center);
}

void schPoint::initPositions(int w, int )
{
    center = w*0.5;
}

bool schPoint::event(QEvent *e)
{
    if (QEventResizedMoved(e))
        recalcPoints();

    return QWidget::event(e);
}

void schPoint::paintEvent(QPaintEvent *)
{
    QPainter painter(this);

    int w = width();
    int h = height();

    initPositions(w, h);
    painter.setRenderHint(QPainter::Antialiasing, true);

    //Box
    painter.setPen(QColor(Qt::black));
    painter.setBrush(QBrush(Qt::black));
    painter.drawRect(0, 0, w, h);
    painter.setBrush(QBrush());
}
