#ifndef SCHSWITCH_H
#define SCHSWITCH_H

#include <QObject>
#include <QWidget>
#include "abstractinoutlines.h"
#include <QtEvents>
#include <QGestureEvent>
#include <QPainter>
#include <QDebug>
#include <QtGlobal>
#include <QTimer>
#include <QPolygon>
#include <QPaintEngine>

class schSwitch : public QWidget, public AbstractInOutLines
{
    Q_OBJECT
public:
    explicit schSwitch(uint numIn = 2, QWidget *parent = nullptr);
    void recalcPoints() override;

    void clearArcsPolygons();
    uint currentConnectedIn;
    int rectCenter = 4;
    int offset;
    QVector<QPolygon*> *vecPolygons;

signals:
    void recalc();
    void indexChanged(int index);

protected:
    bool event(QEvent *) override;
    void paintEvent(QPaintEvent *event) override;

private:
    inline void initPositions(int w, int h);
    int currentHoveredId;
    bool recalcingPoints;

public slots:
};

#endif // SCHSWITCH_H
