#include "schtriangle.h"

schTriangle::schTriangle(triDirection dir, const QString &text, QWidget *parent) :
    QWidget(parent), AbstractInOutLines(1, 1), direction(dir)
{
    textLabel = new QLabel(text, this);
    initPositions(0, 0);
}

void schTriangle::initPositions(int w, int )
{
    if (direction == Down) //todo make other directions
    {
        triaLX = 0;
        triaW = w;
        triaH = w;
        triaLY = 0;
        triaRX = w;
        triaRY = 0;
    }
}

void schTriangle::recalcPoints()
{
    initPositions(width(), height());
    setPtsInXY(0, triaLX + triaW*0.5, triaLY);
    setPtsOutXY(0, triaLX + triaW*0.5, triaH);
}

bool schTriangle::event(QEvent *e)
{
    if (QEventResizedMoved(e))
        recalcPoints();

    return QWidget::event(e);
}

void schTriangle::paintEvent(QPaintEvent *)
{
    QPainter painter(this);

    int w = width();
    int h = height();

    initPositions(w, h);
    painter.setRenderHint(QPainter::Antialiasing, true);

    //Triangle
    painter.setPen(QColor(Qt::black));
    painter.setBrush(QBrush(backgroundColor));
    auto ptsTria = new QPoint[3];
    ptsTria[0].setX(triaLX);
    ptsTria[0].setY(triaLY);
    ptsTria[1].setX(triaRX);
    ptsTria[1].setY(triaRY);
    ptsTria[2].setX(triaW*0.5);
    ptsTria[2].setY(triaH);
    painter.drawPolygon(ptsTria, 3);
    painter.setBrush(QBrush());

    //text
    textLabel->move(triaW*0.38 - textLabel->widthMM(), triaH*0.2 - textLabel->heightMM()*0.5);
}
