#pragma once

#include <QWidget>

class QPushButton;
class QTimer;
class T3dViewer;
class T3DControl: public QWidget
{
    Q_OBJECT

public slots:
    void top_view();
    void save_click();
    void move_toggle(bool checked);
    void scale_click();
    void background_toggle(bool checked);
    void box_toggle(bool checked);
    void allbox_toggle(bool checked);
    void rotate_click();
    void rotate();

    void setVisible(bool visible);
    void resized(QSize newSize);
    void mouseEvent(QEvent *event);

    void onBack();

public:
    T3DControl(T3dViewer *pl, QWidget *parent = nullptr);
    static void setButtonStyle(QPushButton *btn);
    bool event(QEvent *event) override;

    QPushButton *BMoveFlag;
    QPushButton *BBox;
    QPushButton *BABox;
    QPushButton *BRotate;
    QTimer *rot_timer;

    QPushButton *BBack;
    bool bBackExit = true; //if it true Single ESC(or press on btn) will close it, false - firstly exit from submenu
    bool blockVisible = false;
    QColor boundColor = Qt::black;
    qreal boundWidth = 5.0;

    QList<QPushButton*> allBtnsList;

    T3dViewer *pl3;

signals:
    void exit(bool);
};
