#pragma once

#include <QTabWidget>
#include <QTabBar>
#include <QVector>

class TTabWidget : public QTabWidget
{ //vertical, can temporarily hide tabs. unreserves tabbar space when not visible
public:
    TTabWidget(QWidget *parent = nullptr) : QTabWidget(parent) { tabBar()->hide(); }

    bool isTabVisible(int idx) const;
    void setTabVisible(int idx, bool visible); //index, including hidden
    void setAutoHide(bool on) { tabBarAutoHide = on; if (!on) tabBar()->show(); else if (count() <= 1) tabBar()->hide(); }
    int totalCount() const { return count() + hidden_idx.size(); }

    QSize minimumSizeHint() const override { return QTabWidget::minimumSizeHint() - QSize(0, tabBar()->isVisibleTo((QWidget *)this) ? 0 : tabBar()->sizeHint().height()); }
    QSize sizeHint() const override { return QTabWidget::sizeHint() - QSize(0, tabBar()->isVisibleTo((QWidget *)this) ? 0 : tabBar()->sizeHint().height()); }

protected:
    void tabInserted(int index) override;
    void tabRemoved(int index) override;

    bool tabBarAutoHide = true;
    bool doing_stuff = false;
    QVector<int> hidden_idx;
    QVector<QWidget *> hidden_wid;
    QVector<QPair<QIcon, QString> > hidden_data;
};
