#ifndef COBOLTCONTROLLER_HPP
#define COBOLTCONTROLLER_HPP

#include <QWidget>
#include <QPointer>
class QLabel;
#include "controls.h"
#include "edit.hpp"
#include "nstslider.h"
#undef _WIN32_WINNT
#define _WIN32_WINNT 0x0502
#define WIN32_LEAN_AND_MEAN
#define NOMINMAX
#include "windows.h"

class CoboltController : public QObject
{
    Q_OBJECT
public:
    explicit CoboltController(QObject *parent, QString port);
    ~CoboltController() override;
    void Connect();
    void Disconnect();
    void Read(void *ptr, int size);
    void Write(const void *ptr, int size);

    HANDLE hSerial;
    QString port;

signals:

public slots:
    void set_power(double power);
    void clear_fault();
    void laser_on();
    void laser_off();

};

class StatusWidget1;
class CoboltGui : public QWidget
{
    Q_OBJECT
public:
    explicit CoboltGui(QObject *parent, QString suffix, QString port);
    ~CoboltGui() override;

    QPointer<StatusWidget1> deviceStatus;

    NSTSlider *power;
    TwoStateButton *Laser_onoff;
    Edit *power_ew;
    QLabel *cpower;
    QLabel *ccurrent;
    QTimer *upd;

    CoboltController *m_interface;
signals:

public slots:
    void setDeviceStatus(int);
    void set_power(double);
    void laser_onoff(bool);
    void update();

};


#endif // COBOLTCONTROLLER_HPP
