#ifndef MOTIC1080_H
#define MOTIC1080_H

#include <QThread>
#include <QMutex>
#include <QImage>
#include <QCamera>
#include <QCameraImageCapture>
#include <QMediaRecorder>
#include "USBVideo/i_video.hpp"
#include "USBVideo/camvideosurceface.h"
#include <defs.h>

class motic1080: public QThread, public IVideo
{
    Q_OBJECT

public:
    motic1080();
    ~motic1080() override;
    void Start() override;
    void Stop() override;
    QString getName() override { return "Motic1080"; }

    const QObject *getObject() override { return this; }

signals:
    void ImgReceived(QImage Img);

public:
    void setExposure(double value);
    void SetDoAWB(bool bAWB);
    void SetDoAE(bool bAE);

    bool openCamera() override;
    void closeCamera() override;

public slots:
    void processCapturedImage(QImage Img);

private:
    QCamera *camera;
    CamVideoSurceface *videoSurf;
    bool cameraInited;

private slots:
    void displayCameraError(QCamera::Error error);
};


#endif // MOTIC1080_H
