#ifndef MOTICX_HPP
#define MOTICX_HPP

#include <QThread>
#include <QImage>
#include <QNetworkAccessManager>
#include "USBVideo/i_video.hpp"

class MoticX : public QThread, public IVideo
{
    Q_OBJECT

public slots:
    void newData();

public:
    MoticX();
    ~MoticX() override;
    void Start() override;
    void Stop() override;
    QString getName() override { return "Motic X"; }

    const QObject *getObject() override { return this; }

signals:
    void ImgReceived(QImage Img);

public:
    bool openCamera() override;
    void closeCamera() override;

private:
    void run();

    bool init;
    QString ip;
    QNetworkAccessManager manager;
    QNetworkReply *reply;
    QByteArray ba;
    //QNetworkRequest requestSetResolution640;
    int pos_ba00;
};

#endif // MOTICX_HPP
