#ifndef INSPECTR_HPP
#define INSPECTR_HPP

#include "ccd/i_spectr.hpp"
#include <QObject>
#include <QMutex>

class INspectr : public QObject, public I_SPECTR
{
    Q_OBJECT
public slots:

public:
    INspectr(void *hwnd = nullptr); //stored for init/lib use

    bool initialize(int num) override;
    bool shutdown() override;

    QString getName() override;
    bool isReady() override;

    bool preparePixelWl(double pixelsize, int nx, int central_pixel) override;
    double getPixelWl(int pixel_idx) override;

    bool setWl(double wl, bool reset = false) override;
    double getWl() override;
    double getDispersion() override;

    int getGratingCount() override;
    QString getGratingName(int idx) override;
    bool setActiveGrating(int idx, bool reset = false) override;
    int getActiveGrating() override;

    bool setSlitWidth(int port, double width) override;
    double getSlitWidth(int port) override;

    bool setPortPosition(int port, int idx) override;
    int getPortPosition(int port) override;

    QMutex guiThreadLock;
    void *hwnd;
    int cp;
    double pxsize, cwl;
};

#endif // INSPECTR_HPP
