#undef _WIN32_WINNT
#define _WIN32_WINNT 0x0502
#define WIN32_LEAN_AND_MEAN
#include <windows.h>

//code to test stack corruption, gcc;
/*
#include <QDebug>
int _esp;
#define GET_ESP __asm__("mov %esp,__esp");
//vs __asm { mov _esp, esp };
#define PRINT_ESP qDebug() << (void *)_esp;
#define SET_ESP __asm__("mov __esp,%__esp");
*/

#define STATUS_READY   1
#define STATUS_EXECUTE 2
#define STATUS_ERROR   3

//Slit identifiers
#define ID_ENTRANCE_SLIT_1 1
#define ID_EXIT_SLIT_1     2
#define ID_ENTRANCE_SLIT_2 3
#define ID_EXIT_SLIT_2     4

#define ID_ENTRANCE_MIRROR_1 1
#define ID_EXIT_MIRROR_2 2

//Mirror position
#define MRP_AXIAL   1
#define MRP_LATERAL 2

//IMPORTANT!
//GetProcAddress prototypes
//composes n-spectr & monochromator functions together
typedef BOOL (WINAPI *_Proxy_Init)(HWND hAppWnd, DWORD hIcon, BOOL bDemo);
typedef void (WINAPI *_Proxy_Final)();
typedef void (WINAPI *_Proxy_ShowWnd)();
typedef DWORD (WINAPI *_Proxy_GetStatus)();

//only monoch functions
typedef BOOL (WINAPI *_Proxy_SetWL)(double wl, BOOL bReset, int iGr);
typedef double (WINAPI *_Proxy_GetWL)();
typedef BOOL (WINAPI *_Proxy_IsValidWL)(double wl, int iGr);
typedef double (WINAPI *_Proxy_GetDispersion)();
typedef BOOL (WINAPI *_Proxy_GetPixelClbr)(double dbCentrWL, int iCentrPixel, double dbPxlWidth, int iPixel, double* pxlWL);

typedef BOOL (WINAPI *_Proxy_SetSlitWidth)(DWORD slitID, double width, BOOL bReset);
typedef double (WINAPI *_Proxy_GetSlitWidth)(DWORD slitID);
typedef BOOL (WINAPI *_Proxy_SetMirror)(DWORD mirrorID, DWORD dwPos);
typedef BOOL (WINAPI *_Proxy_SetMirror2)(DWORD dwPos); //m266
typedef DWORD (WINAPI *_Proxy_GetMirror)(DWORD mirrorID);
typedef DWORD (WINAPI *_Proxy_GetMirror2)(); //m266

typedef BOOL (WINAPI *_Proxy_SetActiveGrating)(int gr);
typedef int (WINAPI *_Proxy_GetActiveGrating)();
typedef int (WINAPI *_Proxy_GetGratingCount)();
typedef BOOL (WINAPI *_Proxy_GetGratingPrm)(int nIndGrating, double *dGrooves, double *dMaxWL, double *dMinWL);

//only n-spectr functions
typedef BOOL (WINAPI *_NProxy_SetWL)(double wl, BOOL bReset);
typedef double (WINAPI *_NProxy_GetWL)();
typedef BOOL (WINAPI *_NProxy_SetExitNDFilter)(double dOD, BOOL bReset);
typedef double (WINAPI *_NProxy_GetExitNDFilter)();
typedef BOOL (WINAPI *_NProxy_SetEdgeFilterPos)(int nPosition);
typedef int (WINAPI *_NProxy_GetEdgeFilterPos)();
typedef BOOL (WINAPI *_NProxy_SetBeamExpanderPos)(int nWLItemInd, int nDiamItemInd);
typedef BOOL (WINAPI *_NProxy_SetConfocalLensPos)(double dLensPosFocus, double dLensPosX, double dLensPosY, BOOL bReset);
typedef BOOL (WINAPI *_NProxy_SetMonochromatorLensPos)(double dLensPosFocus, double dLensPosX, double dLensPosY, BOOL bReset);

#ifndef NULL
#define NULL 0
#endif

//proxy functions
static HMODULE hnspec = nullptr;
static HMODULE hmonoch = nullptr;
static BOOL monoch = 0;

//warning: case-sensetive names!
//warning: watch array name collision! now just abbreviations
//composes n-spectr & monochromator functions together
static const char *const func_path[3] = { "M266.dll", "M833.dll", "N_Spectr.dll"};
static const char *const func_init[3] = { "M266_Init", "M833_Init", "N_SPECTR_Init" };
static const char *const func_final[3] = { "M266_Final", "M833_Final", "N_SPECTR_Final" };
static const char *const func_sw[3] = { "M266_ShowWnd", "M833_ShowWnd", "N_SPECTR_ShowWnd" };
static const char *const func_gs[3] = { "M266_GetStatus", "M833_GetStatus", "N_SPECTR_GetStatus" };

//only monoch functions
static const char *const func_swl[3] = { "M266_SetWL", "M833_SetWL", "N_SPECTR_SetWL" };
static const char *const func_gwl[3] = { "M266_GetWL", "M833_GetWL", "N_SPECTR_GetWL" };
static const char *const func_iwl[3] = { "M266_IsValidWL", "M833_IsValidWL", "" };
static const char *const func_gdisp[3] = { "M266_GetDispersion", "M833_GetDispersion", "" };
static const char *const func_gpc[3] = { "M266_GetPixelClbr", "M833_GetPixelClbr", "" };

static const char *const func_ssw[3] = { "M266_SetSlitWidth", "M833_SetSlitWidth", "" };
static const char *const func_gsw[3] = { "M266_GetSlitWidth", "M833_GetSlitWidth", "" };
static const char *const func_sm[3] = { "M266_SetMirror", "M833_SetMirror", "" };
static const char *const func_gm[3] = { "M266_GetMirror", "M833_GetMirror", "" };

static const char *const func_sag[3] = { "M266_SetActiveGrating", "M833_SetActiveGrating", "" };
static const char *const func_gag[3] = { "M266_GetActiveGrating", "M833_GetActiveGrating", "" };
static const char *const func_ggc[3] = { "M266_GetGratingCount", "M833_GetGratingCount", "" };
static const char *const func_ggp[3] = { "M266_GetGratingPrm", "M833_GetGratingPrm", "" };

//only n-spectr functions
static const char *const func_sendf[3] = { "", "", "N_SPECTR_SetExitNDFilter" };
static const char *const func_gendf[3] = { "", "", "N_SPECTR_GetExitNDFilter" };
static const char *const func_sefp[3] = { "", "", "N_SPECTR_SetEdgeFilterPos" };
static const char *const func_gefp[3] = { "", "", "N_SPECTR_GetEdgeFilterPos" };
static const char *const func_sbep[3] = { "", "", "N_SPECTR_SetBeamExpanderPos" };
static const char *const func_sclp[3] = { "", "", "N_SPECTR_SetConfocalLensPos" };
static const char *const func_smlp[3] = { "", "", "N_SPECTR_SetMonochromatorLensPos" };

#if defined __cplusplus
extern "C" {
#endif

#ifdef _WIN32
//composes n-spectr & monochromator functions together
#define COMBO_PROXY(function, name_arr) \
    static _##function ptr[2] = { NULL, NULL }; \
    if (!ptr[0] || !ptr[1]) { \
        if (!hnspec) \
            hnspec = LoadLibraryA(func_path[2]); \
        if (!hmonoch) \
            hmonoch = LoadLibraryA(func_path[monoch]); \
\
        if (hnspec) \
            ptr[0] = (_##function)GetProcAddress(hnspec, name_arr[2]); \
        if (hmonoch) \
            ptr[1] = (_##function)GetProcAddress(hmonoch, name_arr[monoch]); \
    }

BOOL Proxy_Init(HWND hAppWnd, DWORD hIcon, BOOL _monoch)
{
    monoch = _monoch;
    COMBO_PROXY(Proxy_Init, func_init)
    if (ptr[0] && ptr[1])
        return ptr[0](hAppWnd, hIcon, FALSE) &
               ptr[1](hAppWnd, hIcon, FALSE);

    return FALSE;
}

void Proxy_Final()
{
    COMBO_PROXY(Proxy_Final, func_final)
    if (ptr[0] && ptr[1]) {
        ptr[0]();
        ptr[1]();
    }
}

void Proxy_ShowWnd()
{
    COMBO_PROXY(Proxy_ShowWnd, func_sw)
    if (ptr[0] && ptr[1]) {
        ptr[0]();
        ptr[1]();
    }
}

DWORD Proxy_GetStatus()
{
    COMBO_PROXY(Proxy_GetStatus, func_gs)
    if (ptr[0] && ptr[1]) {
        return ptr[0]() + ptr[1](); //2 - ready, 3 - ready 1/2, 4 - notready or error 1/2, 6 - error
    }

    return STATUS_READY + STATUS_READY;
}

//only monoch functions
//3rd param - function parameters, is __VA_ARGS__
#define MONOCHROMATOR_PROXY(function, name_arr, ...) \
{ \
    static _##function ptr = NULL; \
    if (!ptr) { \
        if (!hmonoch) \
            hmonoch = LoadLibraryA(func_path[monoch]); \
\
        if (hmonoch) \
            ptr = (_##function)GetProcAddress(hmonoch, name_arr[monoch]); \
    } \
    if (ptr) \
        return ptr(__VA_ARGS__); \
\
    return 0; \
}

BOOL Proxy_SetWL(double wl, BOOL bReset, int iGr)
MONOCHROMATOR_PROXY(Proxy_SetWL, func_swl, wl, bReset, iGr)

double Proxy_GetWL()
MONOCHROMATOR_PROXY(Proxy_GetWL, func_gwl)

BOOL Proxy_IsValidWL(double wl, int iGr)
MONOCHROMATOR_PROXY(Proxy_IsValidWL, func_iwl, wl, iGr)

double Proxy_GetDispersion()
MONOCHROMATOR_PROXY(Proxy_GetDispersion, func_gdisp)

BOOL Proxy_GetPixelClbr(double dbCentrWL, int iCentrPixel, double dbPxlWidth, int iPixel, double *pxlWL)
MONOCHROMATOR_PROXY(Proxy_GetPixelClbr, func_gpc, dbCentrWL, iCentrPixel, dbPxlWidth, iPixel, pxlWL)


BOOL Proxy_SetSlitWidth(DWORD slitID, double width, BOOL bReset)
MONOCHROMATOR_PROXY(Proxy_SetSlitWidth, func_ssw, slitID, width, bReset)

double Proxy_GetSlitWidth(DWORD slitID)
MONOCHROMATOR_PROXY(Proxy_GetSlitWidth, func_gsw, slitID)

BOOL Proxy_SetMirror(DWORD dwPos)
{
    static _Proxy_SetMirror ptr = nullptr;
    static _Proxy_SetMirror2 ptr2 = nullptr; //m266
    if (!ptr && !ptr2) {
        if (!hmonoch)
            hmonoch = LoadLibraryA(func_path[monoch]);

        if (hmonoch) {
            ptr = (_Proxy_SetMirror)GetProcAddress(hmonoch, func_sm[1]);
            ptr2 = (_Proxy_SetMirror2)GetProcAddress(hmonoch, func_sm[0]);
        }
    }
    if (monoch == 0 && ptr2)
        return ptr2(dwPos);
    else if (ptr)
        return ptr(ID_EXIT_MIRROR_2, dwPos);

    return 0;
}

DWORD Proxy_GetMirror()
{
    static _Proxy_GetMirror ptr = nullptr;
    static _Proxy_GetMirror2 ptr2 = nullptr; //m266
    if (!ptr && !ptr2) {
        if (!hmonoch)
            hmonoch = LoadLibraryA(func_path[monoch]);

        if (hmonoch) {
            ptr = (_Proxy_GetMirror)GetProcAddress(hmonoch, func_gm[1]);
            ptr2 = (_Proxy_GetMirror2)GetProcAddress(hmonoch, func_gm[0]);
        }
    }
    if (monoch == 0 && ptr2)
        return ptr2();
    else if (ptr)
        return ptr(ID_EXIT_MIRROR_2);

    return MRP_AXIAL;
}


BOOL Proxy_SetActiveGrating(int gr)
MONOCHROMATOR_PROXY(Proxy_SetActiveGrating, func_sag, gr)

int Proxy_GetActiveGrating()
MONOCHROMATOR_PROXY(Proxy_GetActiveGrating, func_gag)

int Proxy_GetGratingCount()
MONOCHROMATOR_PROXY(Proxy_GetGratingCount, func_ggc)

BOOL Proxy_GetGratingPrm(int nIndGrating, double *dGrooves, double *dMaxWL, double *dMinWL)
MONOCHROMATOR_PROXY(Proxy_GetGratingPrm, func_ggp, nIndGrating, dGrooves, dMaxWL, dMinWL)

//only n-spectr functions
//3rd param - function parameters, is __VA_ARGS__
#define NSPECTR_PROXY(function, name_arr, ...) \
{ \
    static _##function ptr = NULL; \
    if (!ptr) { \
        if (!hnspec) \
            hnspec = LoadLibraryA(func_path[2]); \
\
        if (hnspec) \
            ptr = (_##function)GetProcAddress(hnspec, name_arr[2]); \
    } \
    if (ptr) \
        return ptr(__VA_ARGS__); \
\
    return 0; \
}

BOOL NProxy_SetWL(double wl, BOOL bReset)
NSPECTR_PROXY(NProxy_SetWL, func_swl, wl, bReset)

double NProxy_GetWL()
NSPECTR_PROXY(NProxy_GetWL, func_gwl)

BOOL NProxy_SetExitNDFilter(double dOD, BOOL bReset)
NSPECTR_PROXY(NProxy_SetExitNDFilter, func_sendf, dOD, bReset)

double NProxy_GetExitNDFilter()
NSPECTR_PROXY(NProxy_GetExitNDFilter, func_gendf)

BOOL NProxy_SetEdgeFilterPos(int nPosition)
NSPECTR_PROXY(NProxy_SetEdgeFilterPos, func_sefp, nPosition)

int NProxy_GetEdgeFilterPos()
NSPECTR_PROXY(NProxy_GetEdgeFilterPos, func_gefp)

BOOL NProxy_SetBeamExpanderPos(int nWLItemInd, int nDiamItemInd)
NSPECTR_PROXY(NProxy_SetBeamExpanderPos, func_sbep, nWLItemInd, nDiamItemInd)

BOOL NProxy_SetConfocalLensPos(double dLensPosFocus, double dLensPosX, double dLensPosY, BOOL bReset)
NSPECTR_PROXY(NProxy_SetConfocalLensPos, func_sclp, dLensPosFocus, dLensPosX, dLensPosY, bReset)

BOOL NProxy_SetMonochromatorLensPos(double dLensPosFocus, double dLensPosX, double dLensPosY, BOOL bReset)
NSPECTR_PROXY(NProxy_SetMonochromatorLensPos, func_smlp, dLensPosFocus, dLensPosX, dLensPosY, bReset)

#else
//linux stubs, as no software exist
//composes n-spectr & monochromator functions together
BOOL Proxy_Init(HWND , DWORD , BOOL ) { return 0; }
void Proxy_Final() { }
void Proxy_ShowWnd() { }
DWORD Proxy_GetStatus() { return 2;  }

//only monoch functions
BOOL Proxy_SetWL(double , BOOL , int ) { return 0; }
double Proxy_GetWL() { return 0;  }
BOOL Proxy_IsValidWL(double , int ) { return 0; }
double Proxy_GetDispersion() { return 0; }
BOOL Proxy_GetPixelClbr(double , int , double , int , double *) { return 0; }

BOOL Proxy_SetSlitWidth(DWORD , double , BOOL ) { return 0; }
double Proxy_GetSlitWidth(DWORD ) { return 0; }
BOOL Proxy_SetMirror(DWORD , DWORD ) { return 0; }
DWORD Proxy_GetMirror(DWORD ) { return MRP_AXIAL; }

BOOL Proxy_SetActiveGrating(int ) { return 0; }
int Proxy_GetActiveGrating() { return 0; }
int Proxy_GetGratingCount() { return 0; }
BOOL Proxy_GetGratingPrm(int , double *, double *, double *) { return 0; }

//only n-spectr functions
BOOL NProxy_SetWL(double , BOOL ) { return 0; }
double NProxy_GetWL() { return 0; }
BOOL NProxy_SetExitNDFilter(double , BOOL ) { return 0; }
double NProxy_GetExitNDFilter() { return 0; }
BOOL NProxy_SetEdgeFilterPos(int ) { return 0; }
int NProxy_GetEdgeFilterPos() { return 0; }
BOOL NProxy_SetBeamExpanderPos(int , int ) { return 0; }
BOOL NProxy_SetConfocalLensPos(double , double , double , BOOL ) { return 0; }
BOOL NProxy_SetMonochromatorLensPos(double , double , double , BOOL ) { return 0; }

#endif

#if defined __cplusplus
}
#endif
