#undef _WIN32_WINNT
#define _WIN32_WINNT 0x0502
#define WIN32_LEAN_AND_MEAN
#define NOMINMAX
#include "windows.h"

#define STATUS_READY   2

//Slit identifiers
#define ID_ENTRANCE_SLIT_1 1
#define ID_EXIT_SLIT_1     2
#define ID_ENTRANCE_SLIT_2 3
#define ID_EXIT_SLIT_2     4

//Mirror position
#define MRP_AXIAL   1
#define MRP_LATERAL 2

#if defined __cplusplus
extern "C" {
#endif

//NOTE: "n-spectr" is a confocal monochromator block, "monoch" is a spectrograph

//composes n-spectr & monochromator functions together
BOOL Proxy_Init(HWND hAppWnd, DWORD hIcon, BOOL monoch = 0); //0 - m266, 1 - m833, others undefined behavior
void Proxy_Final();
void Proxy_ShowWnd();
DWORD Proxy_GetStatus();

//only monoch functions
BOOL Proxy_SetWL(double wl, BOOL bReset, int iGr = -1);
double Proxy_GetWL();
BOOL Proxy_IsValidWL(double wl, int iGr = -1);
double Proxy_GetDispersion();
BOOL Proxy_GetPixelClbr(double dbCentrWL, int iCentrPixel, double dbPxlWidth, int iPixel, double *pxlWL);

BOOL Proxy_SetSlitWidth(DWORD slitID, double width, BOOL bReset);
double Proxy_GetSlitWidth(DWORD slitID);
BOOL Proxy_SetMirror(DWORD dwPos);
DWORD Proxy_GetMirror();

BOOL Proxy_SetActiveGrating(int gr);
int Proxy_GetActiveGrating();
int Proxy_GetGratingCount();
BOOL Proxy_GetGratingPrm(int nIndGrating, double *dGrooves, double *dMaxWL, double *dMinWL);

//only n-spectr functions
BOOL NProxy_SetWL(double wl, BOOL bReset);
double NProxy_GetWL();
BOOL NProxy_SetExitNDFilter(double dOD, BOOL bReset);
double NProxy_GetExitNDFilter();
BOOL NProxy_SetEdgeFilterPos(int nPosition);
int NProxy_GetEdgeFilterPos();
BOOL NProxy_SetBeamExpanderPos(int nWLItemInd, int nDiamItemInd);
BOOL NProxy_SetConfocalLensPos(double dLensPosFocus, double dLensPosX, double dLensPosY, BOOL bReset);
BOOL NProxy_SetMonochromatorLensPos(double dLensPosFocus, double dLensPosX, double dLensPosY, BOOL bReset);

#if defined __cplusplus
}
#endif
