#pragma once

#include "defs.h"
#include <QWidget>
#include <QVBoxLayout>
#include <QGroupBox>
class QCheckBox;
class QComboBox;
class Edit;

class TOptionsForMotor: public QWidget
{
    Q_OBJECT
public slots:
    void sl_update();
    void sl_save_to_file();
    void sl_load_from_file();

public:
    double up_speed, up_dist, dist_ready,
    land_speed, land_speed_close,
    land_close_perc, headn_land_exit_dist,
    head_land_offset_dist_1,
    head_land_offset_dist_3;
    bool landUpward;
    bool headLanding = false;
    bool sysOnMAF = false;

    TOptionsForMotor();

    QCheckBox *CB_sysONMAF;
    Edit *LEdUpSpeed;
    Edit *LEdUpDist;
    Edit *LEdDistReady;
    Edit *LEdLandingSpeed;
    Edit *LEdLandingSpeedClose;
    Edit *LEdLandingSpeedCloseC;
    QCheckBox *CB_HeadLanding;
    QCheckBox *CB_landing_up;
    Edit *LEdHeadLandingExitDist;
    Edit *LEdHeadLandingOffsetDist1;
    Edit *LEdHeadLandingOffsetDist3;
};

class TOptionsForShuttle: public QWidget
{
    Q_OBJECT
public slots:
    void sl_update();
    void sl_save_to_file();
    void sl_load_from_file();

public:
    double min_piezo_speed, max_piezo_speed;

    TOptionsForShuttle();

    QVBoxLayout *mainLay;
    QGroupBox *GrBUp;
    QGroupBox *GrBMap;

    Edit *EPMinSpeed;
    Edit *EPMaxSpeed;

    QComboBox* CBKeyRole[15];
    Edit* EKeyStep[15];
    Edit* EKeySpeed[15];
    QCheckBox *CKeyReverse[15];
};
