#include "tools.hpp"

#include <QSettings>
#if (QT_VERSION >= QT_VERSION_CHECK(5, 0, 0))
#include <QWidget>
#include <QWindow>
#endif

void doBeep()
{
    QSettings settings("Param/gui.conf", QSettings::IniFormat);
    if (settings.value("sound_notification", true).toBool())
        qApp->beep();

#if (QT_VERSION >= QT_VERSION_CHECK(5, 1, 0))
    if (qApp->thread() == QThread::currentThread()) {
        foreach (QWidget *w, qApp->topLevelWidgets()) {
            if (w->windowHandle() && w->windowHandle()->isVisible() && !w->windowTitle().isNull()) {
                w->windowHandle()->alert(0);
                break;
            }
        }
    }
#endif
}

double settings_double(QSettings &sett, const QString &path, double def)
{
    bool ok = false;
    double val = sett.value(path, def).toDouble(&ok);
    return ok ? val : def;
}


TNode::~TNode()
{
    if (container)
        container->removeNode(this);
}
